# BEC Widgets documentation

A flexible and extensible framework for building graphical user interfaces in Python, optimized for use in the BEC environment.

<br><br>

<br><br>

````{grid} 2
:gutter: 5

```{grid-item-card}
:link: introduction
:link-type: ref
:img-top: /assets/index_getting_started.svg
:text-align: center
:class-item: index-card

## Introduction

General information about BEC Widgets.
```

```{grid-item-card}
:link: user
:link-type: ref
:img-top:  /assets/index_user_guide.svg
:text-align: center
:class-item: index-card

## User guide

Information for users of BEC Widgets.
```

```{grid-item-card} 
:link: developer
:link-type: ref
:img-top: /assets/index_contribute.svg
:text-align: center
:class-item: index-card

## Developer guide

Information for developers of BEC Widgets. 
```

```{grid-item-card} 
:link: api_reference
:link-type: ref
:img-top: /assets/index_api.svg
:text-align: center
:class-item: index-card

## API reference

Comprehensive reference of all BEC Widget classes, functions, and methods.
```

````


```{toctree}
---
numbered: true
maxdepth: 2
hidden: true
---

introduction/introduction
user/user
developer/developer
api_reference/api_reference
```
